
/*
====================================================================================================
    __  __    __  ___    ____    ____ 
    \ \/ /   /  |/  /   /  _/   / __ \
     \  /   / /|_/ /    / /    / /_/ /
     / /   / /  / /   _/ /    / _, _/ 
    /_/   /_/  /_/   /___/   /_/ |_|  

    YMIR SHADERS

    Copyright (C) 2020 Jessie, RRe36, Niemand

    All Rights Reserved unless otherwise explicitly stated.


    By downloading this you have agreed to the license and terms of use.
    These can be found inside the included license-file
    or here: https://github.com/ymir-graphics/ymir-releases/blob/master/LICENSE

    Violating these terms may be penalized with actions according to the Digital Millennium
    Copyright Act (DMCA), the Information Society Directive and/or similar laws
    depending on your country.

====================================================================================================
*/



float dither_bluenoise() {
    float noise = texelFetch(noisetex, ivec2(gl_FragCoord.xy)%256, 0).a;

    #ifdef taa_enabled
        //noise   = fract(noise + rcp(1.6180339887) * frameCounter);
        noise   = fract(noise + rcp(pi) * frameCounter);
    #endif

    return noise;
}

float dither_bluenoise_slow() {
    float noise = texelFetch(noisetex, ivec2(gl_FragCoord.xy)%256, 0).a;

    #ifdef taa_enabled
        noise   = fract(noise+float(frameCounter)/(pi * 0.5));
    #endif

    return noise;
}

float dither_bluenoise_static() {
    float noise = texelFetch(noisetex, ivec2(gl_FragCoord.xy)%256, 0).a;

    return noise;
}

float ditherGradNoise(){
    return fract(52.9829189*fract(0.06711056*gl_FragCoord.x + 0.00583715*gl_FragCoord.y));
} 

float ditherGradNoiseTemporal(){
    return fract(52.9829189*fract(0.06711056*gl_FragCoord.x + 0.00583715*gl_FragCoord.y + 0.00623715 * (frameCounter * 0.31)));
}