
/*
====================================================================================================
    __  __    __  ___    ____    ____ 
    \ \/ /   /  |/  /   /  _/   / __ \
     \  /   / /|_/ /    / /    / /_/ /
     / /   / /  / /   _/ /    / _, _/ 
    /_/   /_/  /_/   /___/   /_/ |_|  

    YMIR SHADERS

    Copyright (C) 2020 Jessie, RRe36, Niemand

    All Rights Reserved unless otherwise explicitly stated.


    By downloading this you have agreed to the license and terms of use.
    These can be found inside the included license-file
    or here: https://github.com/ymir-graphics/ymir-releases/blob/master/LICENSE

    Violating these terms may be penalized with actions according to the Digital Millennium
    Copyright Act (DMCA), the Information Society Directive and/or similar laws
    depending on your country.

====================================================================================================
*/



float value_3d(vec3 pos) {
    vec3 p  = floor(pos); 
    vec3 b  = fract(pos);

    vec2 uv = (p.xy + (vec2(-97.0) * p.z)) + b.xy;
    vec2 rg = texture(noisetex, (uv)/256.0).xy;

    return cubic_smooth(mix(rg.x, rg.y, b.z));
}
vec3 noise_2d(vec2 pos) {
    return texture(noisetex, pos).xyz;
}

#ifdef PD_3DNOISE
    vec3 noise_3d(vec3 pos) {   //x-large scale worley, y-small scale worley, z-perlin-worley
        return texture(depthtex2, fract(pos)).xyz;
    }
    vec3 noise_3d(vec2 coord) {   //x-large scale worley, y-small scale worley, z-perlin-worley
        vec3 pos    = vec3(coord.x, 0.0, coord.y);
        return noise_3d(pos);
    }
#endif