
/*
====================================================================================================
    __  __    __  ___    ____    ____ 
    \ \/ /   /  |/  /   /  _/   / __ \
     \  /   / /|_/ /    / /    / /_/ /
     / /   / /  / /   _/ /    / _, _/ 
    /_/   /_/  /_/   /___/   /_/ |_|  

    YMIR SHADERS

    Copyright (C) 2020 Jessie, RRe36, Niemand

    All Rights Reserved unless otherwise explicitly stated.


    By downloading this you have agreed to the license and terms of use.
    These can be found inside the included license-file
    or here: https://github.com/ymir-graphics/ymir-releases/blob/master/LICENSE

    Violating these terms may be penalized with actions according to the Digital Millennium
    Copyright Act (DMCA), the Information Society Directive and/or similar laws
    depending on your country.

====================================================================================================
*/

const mat3 _XYZ_AP1 = mat3(
	 1.6410233797, -0.3248032942, -0.2364246952,
	-0.6636628587,  1.6153315917,  0.0167563477,
	 0.0117218943, -0.0082844420,  0.9883948585
);
const mat3 _sRGB_XYZ = mat3(
	0.4124564, 0.3575761, 0.1804375,
	0.2126729, 0.7151522, 0.0721750,
	0.0193339, 0.1191920, 0.9503041
);
const mat3 _D65_D60 = mat3(
	 1.01303,    0.00610531, -0.014971,
	 0.00769823, 0.998165,   -0.00503203,
	-0.00284131, 0.00468516,  0.924507
);

const mat3 _sRGB_AP1 = (_sRGB_XYZ * _D65_D60) * _XYZ_AP1;

const mat3 sRGB_AP1_albedo = (_sRGB_XYZ) * _XYZ_AP1;

const vec3 lumacoeff_rec709 = vec3(0.2125, 0.7154, 0.0721);
const vec3 lumacoeffAP1 = vec3(0.2722287168, 0.6740817658, 0.0536895174);

const float pi = radians(180.0);
const float tau = radians(360.0);
const float piSquared = 9.86960440109;
const float rpi = 1./acos(-1.);
const float hpi = acos(0.);
const float phi = sqrt(5.) * .5 + .5;
const float pi4 = 12.5663706;
const float pidiv2 = pi * 0.5;
const float sunPathRotation = -35.0;    //[-40.0 -35.0 -30.0 -25.0 -20.0 -15.0 -10.0 -5.0 0.0 5.0 10.0 15.0 20.0 25.0 30.0 35.0 40.0]
const float rlog2 = 1.0/log(2.0);
const float golden_angle = tau / phi / pi;

const float wetnessHalflife = 230.0;
const float drynessHalflife = 110.0;
const float centerDepthHalflife = 1.0; //[0.1 0.2 0.3 0.4 0.5 0.6 0.7 0.8 0.9 1.0 1.1 1.2 1.3 1.4 1.5 1.6 1.7 1.8 1.9 2.0 2.25 2.5 2.75 3.0 3.25 3.5 3.75 4.0 4.25 4.5 4.75 5.0 5.5 6.0 7.5 8.0 8.5 9.0 9.5 10.0]