
/*
====================================================================================================
    __  __    __  ___    ____    ____ 
    \ \/ /   /  |/  /   /  _/   / __ \
     \  /   / /|_/ /    / /    / /_/ /
     / /   / /  / /   _/ /    / _, _/ 
    /_/   /_/  /_/   /___/   /_/ |_|  

    YMIR SHADERS

    Copyright (C) 2020 Jessie, RRe36, Niemand

    All Rights Reserved unless otherwise explicitly stated.


    By downloading this you have agreed to the license and terms of use.
    These can be found inside the included license-file
    or here: https://github.com/ymir-graphics/ymir-releases/blob/master/LICENSE

    Violating these terms may be penalized with actions according to the Digital Millennium
    Copyright Act (DMCA), the Information Society Directive and/or similar laws
    depending on your country.

====================================================================================================
*/



/* ------ outputs ------ */
out vec2 coord;

/* ------ uniforms ------ */
uniform vec2 viewSize;

void main() {
    gl_Position = vec4(gl_Vertex.xy * 2.0 - 1.0, 0.0, 1.0);
    coord       = gl_MultiTexCoord0.xy;

    vec2 cres   = max(viewSize, vec2(1920.0, 1080.0));

    #if pass == 0
        gl_Position.y = (gl_Position.y*0.5+0.5)*0.25/cres.y*1080.0*2.0-1.0;
        gl_Position.x = (gl_Position.x*0.5+0.5)*0.5/cres.x*1920.0*2.0-1.0;
    #elif pass == 1
        gl_Position.y = (gl_Position.y*0.5+0.5)*1.0/cres.y*1080.0*2.0-1.0;
        gl_Position.x = (gl_Position.x*0.5+0.5)*0.51/cres.x*1920.0*2.0-1.0;
    #endif

}