#version 450 compatibility

/*
====================================================================================================
    __  __    __  ___    ____    ____ 
    \ \/ /   /  |/  /   /  _/   / __ \
     \  /   / /|_/ /    / /    / /_/ /
     / /   / /  / /   _/ /    / _, _/ 
    /_/   /_/  /_/   /___/   /_/ |_|  

    YMIR SHADERS

    Copyright (C) 2020 Jessie, RRe36, Niemand

    All Rights Reserved unless otherwise explicitly stated.


    By downloading this you have agreed to the license and terms of use.
    These can be found inside the included license-file
    or here: https://github.com/ymir-graphics/ymir-releases/blob/master/LICENSE

    Violating these terms may be penalized with actions according to the Digital Millennium
    Copyright Act (DMCA), the Information Society Directive and/or similar laws
    depending on your country.

====================================================================================================
*/



#include "/lib/universal.glsl"

/*
const int colortex0Format   = RGBA16F;
const int colortex1Format   = RGBA16;
const int colortex2Format   = RGBA16;
const int colortex3Format   = RGBA16F;
const int colortex4Format   = RGBA16F;
const int colortex5Format   = RGBA16F;
const int colortex6Format   = RGBA8;
const int colortex7Format   = RGBA16F;

const vec4 colortex0ClearColor = vec4(0.0, 0.0, 0.0, 1.0);
const vec4 colortex3ClearColor = vec4(0.0, 0.0, 0.0, 0.0);

const bool colortex5Clear = false;
*/

/* ------ framebuffer attachment outputs ------ */
/*DRAWBUFFERS:4*/
layout(location = 0) out vec4 atmosphere_data;


/* ------ inputs from vertex stage ------ */
in vec2 coord;

flat in vec3 atmosIlluminance;


/* ------ uniforms ------ */
uniform float eyeAltitude;

uniform vec2 viewSize;

uniform vec3 sunVector;
uniform vec3 moonVector;


/* ------ includes ------ */
#include "/lib/util/spectral.glsl"
#include "/lib/atmosphere/constants.glsl"
#include "/lib/atmosphere/transmittance.glsl"
#include "/lib/atmosphere/phase.glsl"
#include "/lib/atmosphere/calculate.glsl"
#include "/lib/atmosphere/project.glsl"

void main() {
    atmosphere_data     = vec4(0.0, 0.0, 0.0, 1.0);

    if (coord.y >= exp2(-SKY_RENDER_LOD) || coord.x >= exp2(-SKY_RENDER_LOD)) discard;

    vec3 worldDir       = unprojectSky(coord);
    
    atmosphere_data.rgb = calculateAtmosphere(worldDir, atmosIlluminance);
}