#version 450 compatibility

/*
====================================================================================================
    __  __    __  ___    ____    ____ 
    \ \/ /   /  |/  /   /  _/   / __ \
     \  /   / /|_/ /    / /    / /_/ /
     / /   / /  / /   _/ /    / _, _/ 
    /_/   /_/  /_/   /___/   /_/ |_|  

    YMIR SHADERS

    Copyright (C) 2020 Jessie, RRe36, Niemand

    All Rights Reserved unless otherwise explicitly stated.


    By downloading this you have agreed to the license and terms of use.
    These can be found inside the included license-file
    or here: https://github.com/ymir-graphics/ymir-releases/blob/master/LICENSE

    Violating these terms may be penalized with actions according to the Digital Millennium
    Copyright Act (DMCA), the Information Society Directive and/or similar laws
    depending on your country.

====================================================================================================
*/



#include "/lib/universal.glsl"


/* ------ outputs ------ */
out vec2 coord;

#ifdef rsm_enabled
    out vec3 lightVector;

    vec2 rotate_coord(vec2 pos, const float angle) {
        return vec2(cos(angle)*pos.x + sin(angle)*pos.y, 
                    cos(angle)*pos.y - sin(angle)*pos.x);
    }
#endif

void main() {
    gl_Position    = vec4(gl_Vertex.xy * 2.0 - 1.0, 0.0, 1.0);
    coord          = gl_MultiTexCoord0.xy;

    #ifdef rsm_enabled
        lightVector    = vec3(0.0, 1.0, 0.0);
        lightVector.yz = rotate_coord(lightVector.yz, radians(sunPathRotation));
        lightVector    = normalize(lightVector);
    #endif
}