#version 450 compatibility


/*
====================================================================================================
    __  __    __  ___    ____    ____ 
    \ \/ /   /  |/  /   /  _/   / __ \
     \  /   / /|_/ /    / /    / /_/ /
     / /   / /  / /   _/ /    / _, _/ 
    /_/   /_/  /_/   /___/   /_/ |_|  

    YMIR SHADERS

    Copyright (C) 2020 Jessie, RRe36, Niemand

    All Rights Reserved unless otherwise explicitly stated.


    By downloading this you have agreed to the license and terms of use.
    These can be found inside the included license-file
    or here: https://github.com/ymir-graphics/ymir-releases/blob/master/LICENSE

    Violating these terms may be penalized with actions according to the Digital Millennium
    Copyright Act (DMCA), the Information Society Directive and/or similar laws
    depending on your country.

====================================================================================================
*/



#include "/lib/universal.glsl"


/* ------ framebuffer attachment outputs ------ */
/*DRAWBUFFERS:3*/
layout(location = 0) out vec4 indirectLight_data;


/* ------ inputs from vertex stage ------ */
in vec2 coord;     //this is always the topmost variable since it's needed everywhere


uniform sampler2D colortex3;
uniform sampler2D colortex6;

uniform sampler2D depthtex0;

uniform float far, near;

uniform vec2 pixelSize, viewSize;


/* ------ indirect lighting filter ------ */
float depth_lin(float depth) {
    return (2.0*near) / (far+near-depth * (far-near));
}

#define PD_FILTERLOD 2.0
#include "/lib/fragment/waveletFilter.glsl"

void main() {
    indirectLight_data  = stex(colortex3);

    #ifdef rsm_enabled
        vec2 aoCoord    = coord * 2.0;

        if (clamp(aoCoord, 0.0 - pixelSize, 1.0 + pixelSize) == aoCoord) {
            indirectLight_data  = filter_3x3(colortex3, depthtex0, coord, 2);
        }
    #endif

    indirectLight_data  = clamp_drawbuffer(indirectLight_data);
}